]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blob - make.sh
Alle htdocs nach /srv/web verschoben...
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2006 IPFire-Team <info@ipfire.eu>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0b" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which version should be compiled? (full|light|voice)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j12"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 grub
288 lfsmake2 gawk
289 lfsmake2 gettext
290 lfsmake2 grep
291 lfsmake2 groff
292 lfsmake2 gzip
293 lfsmake2 inetutils
294 lfsmake2 iproute2
295 lfsmake2 kbd
296 lfsmake2 less
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 net-tools
302 lfsmake2 patch
303 lfsmake2 psmisc
304 lfsmake2 shadow
305 lfsmake2 sysklogd
306 lfsmake2 sysvinit
307 lfsmake2 tar
308 lfsmake2 texinfo
309 lfsmake2 udev
310 lfsmake2 util-linux
311 lfsmake2 vim
312 }
313
314 buildipfire() {
315 LOGFILE="$BASEDIR/log/_build.ipfire.log"
316 export LOGFILE
317 ipfiremake configroot
318 ipfiremake dhcp
319 ipfiremake dhcpcd
320 ipfiremake libusb
321 ipfiremake libpcap
322 # Temporary disabled.
323 # ipfiremake linux-atm
324 ipfiremake ppp
325 ipfiremake rp-pppoe
326 ipfiremake unzip
327 ipfiremake linux SMP=1
328 # ipfiremake 3cp4218 PASS=SMP
329 # ipfiremake amedyn PASS=SMP
330 # ipfiremake cxacru PASS=SMP
331 # ipfiremake eagle PASS=SMP
332 # ipfiremake cnx_pci PASS=SMP
333 # ipfiremake fcdsl PASS=SMP
334 # ipfiremake fcdsl2 PASS=SMP
335 # ipfiremake fcdslsl PASS=SMP
336 # ipfiremake fcdslusb PASS=SMP
337 # ipfiremake fcdslslusb PASS=SMP
338 # ipfiremake fcpci PASS=SMP
339 # ipfiremake fcclassic PASS=SMP
340 # ipfiremake pulsar PASS=SMP
341 # ipfiremake unicorn PASS=SMP
342 # ipfiremake promise-sata-300-tx PASS=SMP
343 ipfiremake zaptel PASS=S
344 ipfiremake linux
345 # ipfiremake 3cp4218
346 # ipfiremake amedyn
347 # ipfiremake cxacru
348 # ipfiremake eciadsl
349 # ipfiremake eagle
350 # ipfiremake speedtouch
351 # ipfiremake cnx_pci
352 # ipfiremake fcdsl
353 # ipfiremake fcdsl2
354 # ipfiremake fcdslsl
355 # ipfiremake fcdslusb
356 # ipfiremake fcdslslusb
357 # ipfiremake fcpci
358 # ipfiremake fcclassic
359 # ipfiremake pulsar
360 # ipfiremake unicorn
361 # ipfiremake promise-sata-300-tx
362 ipfiremake zaptel
363 # ipfiremake pcmciautils
364 ipfiremake expat
365 ipfiremake gdbm
366 ipfiremake gmp
367 ipfiremake pam
368 ipfiremake openssl
369 ipfiremake python
370 ipfiremake libnet
371 ipfiremake libjpeg
372 ipfiremake libpng
373 ipfiremake libtiff
374 ipfiremake lcms
375 ipfiremake libmng
376 ipfiremake freetype
377 ipfiremake libart
378 ipfiremake gd
379 ipfiremake popt
380 ipfiremake pcre
381 ipfiremake slang
382 ipfiremake newt
383 ipfiremake libcap
384 ipfiremake pciutils
385 ipfiremake libxml2
386 ipfiremake BerkeleyDB
387 ipfiremake mysql
388 ipfiremake cyrus-sasl
389 ipfiremake openldap
390 # ipfiremake cyrus-sasl PASS=L # Doesn't work yet. Thereby there's the question: Do we really need this?
391 ipfiremake apache2
392 ipfiremake php
393 ipfiremake subversion
394 ipfiremake apache2 PASS=C
395 ipfiremake arping
396 ipfiremake beep
397 ipfiremake bind
398 ipfiremake capi4k-utils
399 ipfiremake cdrtools
400 ipfiremake dnsmasq
401 ipfiremake dosfstools
402 ipfiremake reiserfsprogs
403 ipfiremake ethtool
404 ipfiremake ez-ipupdate
405 ipfiremake fcron
406 ipfiremake GD
407 ipfiremake gnupg
408 ipfiremake hdparm
409 ipfiremake ibod
410 ipfiremake initscripts
411 ipfiremake iptables
412 ipfiremake ipac-ng
413 ipfiremake ipaddr
414 ipfiremake iptstate
415 ipfiremake iputils
416 ipfiremake l7-protocols
417 # ipfiremake isapnptools # ERROR :(
418 # ipfiremake isdn4k-utils # What about mISDN???
419 ipfiremake kudzu
420 ipfiremake logrotate
421 ipfiremake logwatch
422 ipfiremake mingetty
423 ipfiremake misc-progs
424 ipfiremake mtools
425 ipfiremake nano
426 ipfiremake nash
427 ipfiremake nasm
428 ### The Perl Modules have to be updated! I will skip this now!
429 ipfiremake URI
430 ipfiremake HTML-Tagset
431 ipfiremake HTML-Parser
432 ipfiremake Compress-Zlib
433 ipfiremake Digest
434 ipfiremake Digest-SHA1
435 ipfiremake Digest-HMAC
436 ipfiremake libwww-perl
437 ipfiremake Net-DNS
438 ipfiremake Net-IPv4Addr
439 ipfiremake Net_SSLeay
440 ipfiremake IO-Stringy
441 ipfiremake Unix-Syslog
442 ipfiremake Mail-Tools
443 ipfiremake MIME-Tools
444 ipfiremake Net-Server
445 ipfiremake Convert-TNEF
446 ipfiremake Convert-UUlib
447 ipfiremake Archive-Tar
448 ipfiremake Archive-Zip
449 ipfiremake Text-Tabs+Wrap
450 ipfiremake Locale-Country
451 ipfiremake GeoIP
452 ###
453 ipfiremake fwhits
454 ipfiremake noip_updater
455 ipfiremake ntp
456 ipfiremake oinkmaster
457 ipfiremake openssh
458 ipfiremake openswan
459 ipfiremake pptpclient
460 ipfiremake rrdtool
461 ipfiremake setserial
462 ipfiremake setup
463 ipfiremake snort
464 ipfiremake squid
465 ipfiremake squid-graph
466 ipfiremake squidguard
467 # ipfiremake tcpdump
468 ipfiremake traceroute
469 ipfiremake vlan
470 ipfiremake wireless
471 ipfiremake libsafe
472 ipfiremake 3c5x9setup
473 ipfiremake pakfire
474 ipfiremake startscripts
475 ipfiremake java
476 ipfiremake bootsplash
477 ipfiremake spandsp
478 ipfiremake lzo
479 ipfiremake openvpn
480 ipfiremake pkg-config
481 ipfiremake glib
482 ipfiremake pammysql
483 ipfiremake xinetd
484 ipfiremake ghostscript
485 ipfiremake cups
486 ipfiremake samba
487 ipfiremake sudo
488 ipfiremake mc
489 ipfiremake wget
490 ipfiremake wput
491 ipfiremake bridge-utils
492 ipfiremake screen
493 ipfiremake hddtemp
494 ipfiremake smartmontools
495 ipfiremake htop
496 ipfiremake lynx
497 ipfiremake postfix
498 ipfiremake procmail
499 ipfiremake fetchmail
500 ipfiremake cyrusimap
501 ipfiremake webcyradm
502 ipfiremake mailx
503 ipfiremake clamav
504 ipfiremake razor
505 ipfiremake spamassassin
506 ipfiremake amavisd
507 ipfiremake stund
508 ipfiremake libpri
509 # ipfiremake bristuff
510 ipfiremake asterisk
511 ipfiremake mpg123
512 ipfiremake libmad
513 ipfiremake libogg
514 ipfiremake libvorbis
515 ipfiremake lame
516 ipfiremake xvid
517 ipfiremake mpeg2dec
518 ipfiremake ffmpeg
519 ipfiremake sox
520 ipfiremake gnump3d
521 ipfiremake videolan
522 ipfiremake applejuice
523 ipfiremake ocaml
524 ipfiremake mldonkey
525 ipfiremake ntop
526 ipfiremake rsync
527 ipfiremake tcpwrapper
528 ipfiremake portmap
529 ipfiremake nfs
530 ipfiremake nmap
531 ipfiremake mbmon
532 ipfiremake iftop
533 ipfiremake ncftp
534 ipfiremake cftp
535 ipfiremake etherwake
536 ipfiremake ethereal
537 ipfiremake tftp-hpa
538 ipfiremake iptraf
539 ipfiremake nagios
540 ipfiremake yasuc
541 }
542
543 buildinstaller() {
544 # Run installer scripts one by one
545 LOGFILE="$BASEDIR/log/_build.installer.log"
546 export LOGFILE
547 ipfiremake syslinux
548 ipfiremake uClibc
549 installmake busybox
550 installmake udev
551 installmake slang
552 installmake newt
553 installmake gettext
554 installmake kbd
555 installmake popt
556 installmake sysvinit
557 installmake misc-progs
558 installmake e2fsprogs
559 installmake reiserfsprogs
560 installmake sysfsutils
561 installmake util-linux
562 installmake pciutils
563 installmake pcmciautils
564 installmake kudzu
565 installmake installer
566 installmake scsi.img # this is to be deleted
567 installmake driver.img # this is to be deleted
568 installmake initrd
569 installmake boot.img # this is to be deleted
570 # ipfiremake as86 # this is to be deleted
571 # ipfiremake mbr # this is to be deleted
572 }
573
574 buildpackages() {
575 LOGFILE="$BASEDIR/log/_build.packages.log"
576 export LOGFILE
577 echo "... see detailed log in _build.*.log files" >> $LOGFILE
578
579 installmake strip
580
581 # Generating list of packages used
582 echo -n "Generating packages list from logs" | tee -a $LOGFILE
583 rm -f $BASEDIR/doc/packages-list
584 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
585 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
586 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
587 fi
588 done
589 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
590 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
591 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
592 rm -f $BASEDIR/doc/packages-list
593 # packages-list.txt is ready to be displayed for wiki page
594 beautify message DONE
595
596 # Create images for install
597 ipfiremake cdrom
598 ipfiremake pxe
599 cp -f $LFS/install/images/{*.iso,*.tgz} $BASEDIR >> $LOGFILE 2>&1
600
601 # ipfirepackages
602
603 # Cleanup
604 stdumount
605 rm -rf $BASEDIR/build/tmp/*
606
607 # Generating total list of files
608 echo "`date -u '+%b %e %T'`: Generating files list from logs" | tee -a $LOGFILE
609 rm -f $BASEDIR/log/FILES
610 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
611 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
612 echo "##" >>$BASEDIR/log/FILES
613 echo "## `basename $i`" >>$BASEDIR/log/FILES
614 echo "##" >>$BASEDIR/log/FILES
615 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
616 fi
617 done
618 cd $BASEDIR/packages; ls -w1 *.ipfire | awk -F ".ipfire" '{ print $1 }' > $BASEDIR/packages/packages_list.txt
619 echo -n "###EOF###" >> $BASEDIR/packages/packages_list.txt
620
621 cd $PWD
622
623 }
624
625 ipfirepackages() {
626 if [ -d "$BASEDIR/packages" ]; then
627 for i in `ls $BASEDIR/packages`; do
628 touch $BASEDIR/build/install/packages/$i.empty
629 done
630 fi
631 # ipfiredist amavisd
632 ipfiredist applejuice
633 ipfiredist asterisk
634 ipfiredist clamav
635 ipfiredist cups
636 ipfiredist cyrusimap
637 ipfiredist fetchmail
638 ipfiredist ffmpeg
639 ipfiredist gnump3d
640 ipfiredist iptraf
641 ipfiredist java
642 ipfiredist lame
643 ipfiredist libmad
644 ipfiredist libogg
645 ipfiredist libvorbis
646 ipfiredist mailx
647 ipfiredist mldonkey
648 ipfiredist mpeg2dec
649 ipfiredist nagios
650 ipfiredist nfs
651 ipfiredist nmap
652 ipfiredist ntop
653 ipfiredist portmap
654 ipfiredist postfix
655 ipfiredist procmail
656 ipfiredist samba
657 ipfiredist sox
658 ipfiredist spamassassin
659 ipfiredist subversion
660 ipfiredist videolan
661 ipfiredist webcyradm
662 ipfiredist xvid
663 ipfiredist yasuc
664 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
665 mv -f $LFS/install/packages/*.{ipfire,md5} $BASEDIR/packages >> $LOGFILE 2>&1
666 rm -rf $BASEDIR/build/install/packages/*
667 }
668
669 # See what we're supposed to do
670 case "$1" in
671 build)
672 clear
673 BUILDMACHINE=`uname -m`
674 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
675 #only restore on a clean disk
676 if [ ! -f log/cleanup-toolchain-2-tools ]; then
677 if [ ! -n "$PACKAGE" ]; then
678 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
679 prepareenv
680 buildtoolchain
681 else
682 PACKAGENAME=${PACKAGE%.tar.gz}
683 beautify build_stage "Packaged toolchain compilation"
684 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
685 tar zxf $PACKAGE
686 prepareenv
687 else
688 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
689 fi
690 fi
691 else
692 echo -n "Using installed toolchain" | tee -a $LOGFILE
693 beautify message SKIP
694 prepareenv
695 fi
696
697 beautify build_stage "Building base"
698 buildbase
699
700 beautify build_stage "Building IPFire"
701 buildipfire
702
703 # Setzen des IPFire Builds
704 if [ "$FIREBUILD" ]; then
705 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
706 else
707 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
708 fi
709
710 beautify build_stage "Building installer"
711 buildinstaller
712
713 beautify build_stage "Building packages"
714 buildpackages
715 ;;
716 shell)
717 # enter a shell inside LFS chroot
718 # may be used to changed kernel settings
719 prepareenv
720 entershell
721 ;;
722 changelog)
723 echo -n "Loading new Changelog from SVN: "
724 svn log http://svn.ipfire.eu/svn/ipfire > doc/ChangeLog
725 echo "Finished!"
726 ;;
727 clean)
728 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
729 $LOSETUP -d $i 2>/dev/null
730 done
731 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
732 umount $i
733 done
734 stdumount
735 for i in `seq 0 7`; do
736 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
737 umount /dev/loop${i} 2>/dev/null;
738 losetup -d /dev/loop${i} 2>/dev/null;
739 fi;
740 done
741 rm -rf $BASEDIR/build
742 rm -rf $BASEDIR/cdrom
743 rm -rf $BASEDIR/packages
744 rm -rf $BASEDIR/log
745 if [ -h /tools ]; then
746 rm -f /tools
747 fi
748 ;;
749 newpak)
750 # create structure for a new package
751 echo -e "Name of the new package: $2"
752 if [ ! -f "lfs/$2" ]; then
753 echo "`date -u '+%b %e %T'`: Creating directory src/paks/$2"
754 mkdir -p src/paks/$2
755 cd src/paks/$2
756 echo "`date -u '+%b %e %T'`: Creating files"
757 cp $BASEDIR/lfs/postfix $BASEDIR/lfs/$2
758
759 touch ROOTFILES
760 touch {,un}install.sh
761 ## install.sh
762 echo '#!/bin/bash' > install.sh
763 echo '#' >> install.sh
764 echo '#################################################################' >> install.sh
765 echo '# #' >> install.sh
766 echo '# This file belongs to IPFire Firewall - GPLv2 - www.ipfire.org #' >> install.sh
767 echo '# #' >> install.sh
768 echo '#################################################################' >> install.sh
769 echo '#' >> install.sh
770 echo '# Extract the files' >> install.sh
771 echo 'tar xfz files.tgz -C /' >> install.sh
772 echo 'cp -f ROOTFILES /opt/pakfire/installed/ROOTFILES.$2' >> install.sh
773 ## uninstall.sh
774 echo '#!/bin/bash' > uninstall.sh
775 echo '#################################################################' >> uninstall.sh
776 echo '# #' >> uninstall.sh
777 echo '# This file belongs to IPFire Firewall - GPLv2 - www.ipfire.org #' >> uninstall.sh
778 echo '# #' >> uninstall.sh
779 echo '#################################################################' >> uninstall.sh
780 echo '#' >> uninstall.sh
781 echo '# Delete the files' >> uninstall.sh
782 echo '## Befehl fehlt noch' >> uninstall.sh
783 echo 'rm -f /opt/pakfire/installed/ROOTFILES.$2' >> uninstall.sh
784 echo "`date -u '+%b %e %T'`: Adding files to SVN"
785 cd - && svn add lfs/$2 && svn add src/paks/$2
786
787 echo -n "Do you want to remove the folders? [y/n]"
788 read REM
789 if [ "$REM" == "y" ]; then
790 echo "Removing the folders..."
791 svn del src/paks/$2 --force
792 else
793 echo "Folders are kept."
794 fi
795 else
796 echo "$2 already exists"
797 fi
798 exit 0
799 ;;
800 downloadsrc)
801 if [ ! -d $BASEDIR/cache ]; then
802 mkdir $BASEDIR/cache
803 fi
804 mkdir -p $BASEDIR/log
805 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
806 FINISHED=0
807 cd $BASEDIR/lfs
808 for c in `seq $MAX_RETRIES`; do
809 if (( FINISHED==1 )); then
810 break
811 fi
812 FINISHED=1
813 cd $BASEDIR/lfs
814 for i in *; do
815 if [ -f "$i" -a "$i" != "Config" ]; then
816 echo -ne "Loading $i"
817 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
818 if [ $? -ne 0 ]; then
819 beautify message FAIL
820 FINISHED=0
821 else
822 if [ $c -eq 1 ]; then
823 beautify message DONE
824 fi
825 fi
826 fi
827 done
828 done
829 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
830 ERROR=0
831 for i in *; do
832 if [ -f "$i" -a "$i" != "Config" ]; then
833 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
834 if [ $? -ne 0 ]; then
835 echo -ne "MD5 difference in lfs/$i"
836 beautify message FAIL
837 ERROR=1
838 fi
839 fi
840 done
841 if [ $ERROR -eq 0 ]; then
842 echo -ne "${BOLD}all files md5sum match${NORMAL}"
843 beautify message DONE
844 else
845 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
846 beautify message FAIL
847 fi
848 cd - >/dev/null 2>&1
849 ;;
850 toolchain)
851 clear
852 prepareenv
853 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
854 buildtoolchain
855 BUILDMACHINE=`uname -m`
856 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
857 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
858 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
859 build/{bin,etc,usr/bin,usr/local} \
860 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
861 log >> $LOGFILE
862 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
863 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
864 stdumount
865 ;;
866 gettoolchain)
867 BUILDMACHINE=`uname -m`
868 # arbitrary name to be updated in case of new toolchain package upload
869 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
870 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
871 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
872 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
873 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
874 cd $BASEDIR/cache/toolchains
875 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
876 if [ $? -ne 0 ]; then
877 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
878 else
879 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
880 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
881 else
882 exiterror "$PACKAGE.md5 did not match, check downloaded package"
883 fi
884 fi
885 else
886 echo "Toolchain is already downloaded. Exiting..."
887 fi
888 ;;
889 othersrc)
890 prepareenv
891 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
892 chroot $LFS /tools/bin/env -i HOME=/root \
893 TERM=$TERM PS1='\u:\w\$ ' \
894 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
895 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
896 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
897 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
898 if [ $? -eq "0" ]; then
899 beautify message DONE
900 else
901 beautify message FAIL
902 fi
903 stdumount
904 ;;
905 svn)
906 case "$2" in
907 update|up)
908 # clear
909 echo -ne "Loading the latest source files...\n"
910 if [ $3 ]; then
911 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
912 else
913 svn update | tee -a $PWD/log/_build.svn.update.log
914 fi
915 if [ $? -eq "0" ]; then
916 beautify message DONE
917 else
918 beautify message FAIL
919 exit 1
920 fi
921 echo -ne "Writing the svn-info to a file"
922 svn info > $PWD/svn_status
923 if [ $? -eq "0" ]; then
924 beautify message DONE
925 else
926 beautify message FAIL
927 exit 1
928 fi
929 chmod 755 $0
930 exit 0
931 ;;
932 commit|ci)
933 clear
934 if [ -f /usr/bin/mcedit ]; then
935 export EDITOR=/usr/bin/mcedit
936 fi
937 if [ -f /usr/bin/nano ]; then
938 export EDITOR=/usr/bin/nano
939 fi
940 echo -ne "Selecting editor $EDITOR..."
941 beautify message DONE
942 if [ -e /sbin/yast ]; then
943 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
944 $0 changelog
945 fi
946 fi
947 svn commit
948 $0 svn up
949 $0 uploadsrc
950 ;;
951 dist)
952 if [ $3 ]; then
953 SVN_REVISION=$3
954 fi
955 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
956 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
957 exit 0
958 fi
959 echo -en "REV $SVN_REVISION: Downloading..."
960 svn export http://svn.ipfire.eu/svn/ipfire/trunk ipfire-source/ --force > /dev/null
961 svn log http://svn.ipfire.eu/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
962 #svn info http://svn.ipfire.eu/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
963 evaluate 1
964
965 echo -en "REV $SVN_REVISION: Compressing files..."
966 if [ -e ipfire-source/trunk/make.sh ]; then
967 chmod 755 ipfire-source/trunk/make.sh
968 fi
969 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
970 evaluate 1
971 echo -en "REV $SVN_REVISION: Cleaning up..."
972 rm ipfire-source/ -r
973 evaluate 1
974 ;;
975 diff|di)
976 echo -ne "Make a local diff to last svn revision"
977 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
978 evaluate 1
979 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
980 ;;
981 esac
982 ;;
983 uploadsrc)
984 PWD=`pwd`
985 cd $BASEDIR/cache/
986 echo -e "Uploading cache to ftp server:"
987 ncftpls -u $IPFIRE_FTP_USER_INT -p $IPFIRE_FTP_PASS_INT ftp://$IPFIRE_FTP_URL_INT$IPFIRE_FTP_PATH_INT/ > /var/tmp/ftplist
988 for i in *; do
989 if [ "$i" == "toolchains" ]; then continue; fi
990 grep -q $i /var/tmp/ftplist
991 if [ "$?" -ne "0" ]; then
992 echo -ne "$i"
993 ncftpput -bb -u $IPFIRE_FTP_USER_INT -p $IPFIRE_FTP_PASS_INT $IPFIRE_FTP_URL_INT $IPFIRE_FTP_PATH_INT/ $i >> $BASEDIR/log/_build.uploadsrc.log 2>&1
994 if [ "$?" -eq "0" ]; then
995 beautify message DONE
996 else
997 beautify message FAIL
998 fi
999 fi
1000 done
1001 rm -f /var/tmp/ftplist
1002 UL_TIME_START=`date +'%s'`
1003 ncftpbatch -d > /dev/null 2>&1
1004 while ps acx | grep -q ncftpbatch
1005 do
1006 UL_TIME=$(expr `date +'%s'` - $UL_TIME_START)
1007 echo -ne "\r ${UL_TIME}s : Upload is running..."
1008 sleep 1
1009 done
1010 beautify message DONE
1011 cd $PWD
1012 exit 0
1013 ;;
1014 upload)
1015 case "$2" in
1016 iso)
1017 echo -e "Uploading the iso to $IPFIRE_FTP_URL_EXT."
1018 cat <<EOF > .ftp-commands
1019 mkdir $IPFIRE_FTP_PATH_EXT
1020 ls -lah
1021 quit
1022 EOF
1023 ncftp -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT < .ftp-commands
1024 rm -f .ftp-commands
1025 md5sum ipfire-install-$VERSION.i386.iso > ipfire-install-$VERSION.i386.iso.md5
1026 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ ipfire-install-$VERSION.i386.iso
1027 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ ipfire-install-$VERSION.i386.iso.md5
1028 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ ipfire-source-r$SVN_REVISION.tar.gz
1029 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ svn_status
1030 if [ "$?" -eq "0" ]; then
1031 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $IPFIRE_FTP_URL_EXT$IPFIRE_FTP_PATH_EXT/."
1032 else
1033 echo -e "There was an error while uploading the iso to the ftp server."
1034 exit 1
1035 fi
1036 if [ "$3" = "--with-sources-cd" ]; then
1037 ncftpput -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT $IPFIRE_FTP_PATH_EXT/ ipfire-sources-cd-$VERSION.$MACHINE.iso
1038 fi
1039 ;;
1040 paks)
1041 cat <<EOF > .ftp-commands
1042 mkdir $IPFIRE_FTP_PATH_PAK
1043 ls -lah
1044 quit
1045 EOF
1046 ncftp -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK < .ftp-commands
1047 rm -f .ftp-commands
1048 ncftpput -z -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK $IPFIRE_FTP_PATH_PAK/ packages/*
1049 if [ "$?" -eq "0" ]; then
1050 echo -e "The packages were successfully uploaded to $IPFIRE_FTP_URL_PAK$IPFIRE_FTP_PATH_PAK/."
1051 else
1052 echo -e "There was an error while uploading the packages to the ftp server."
1053 exit 1
1054 fi
1055 ;;
1056 esac
1057 ;;
1058 batch)
1059 if [ "$2" -eq "--background" ]; then
1060 batch_script
1061 exit $?
1062 fi
1063 if [ `screen -ls | grep -q ipfire` ]; then
1064 echo "Build is already running, sorry!"
1065 exit 1
1066 else
1067 if [ "$2" = "--rebuild" ]; then
1068 export IPFIRE_REBUILD=1
1069 echo "REBUILD!"
1070 else
1071 export IPFIRE_REBUILD=0
1072 fi
1073 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1074 screen -dmS ipfire $0 batch --background
1075 evaluate 1
1076 exit 0
1077 fi
1078 ;;
1079 watch)
1080 watch_screen
1081 ;;
1082 pxe)
1083 case "$2" in
1084 start)
1085 start_tftpd
1086 ;;
1087 stop)
1088 stop_tftpd
1089 ;;
1090 reload)
1091 reload_tftpd
1092 ;;
1093 esac
1094 exit 0
1095 ;;
1096 "")
1097 clear
1098 svn info
1099 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1100 do
1101 case $name in
1102 "IPFIRE: Downloadsrc")
1103 $0 downloadsrc
1104 ;;
1105 "IPFIRE: Build (silent)")
1106 $0 build-silent
1107 ;;
1108 "IPFIRE: Watch Build")
1109 $0 watch
1110 ;;
1111 "IPFIRE: Batch")
1112 $0 batch
1113 ;;
1114 "IPFIRE: Clean")
1115 $0 clean
1116 ;;
1117 "SVN: Update")
1118 $0 svn update
1119 ;;
1120 "Help")
1121 echo "Usage: $0 {build|changelog|clean|gettoolchain|newpak|downloadsrc|shell|sync|toolchain}"
1122 cat doc/make.sh-usage
1123 ;;
1124 "LOG: Tail")
1125 tail -f log/_*
1126 ;;
1127 "Exit")
1128 break
1129 ;;
1130 esac
1131 done
1132 ;;
1133 *)
1134 echo "Usage: $0 {build|changelog|clean|gettoolchain|newpak|downloadsrc|shell|sync|toolchain}"
1135 cat doc/make.sh-usage
1136 ;;
1137 esac